<template>
  <div class="main-content abnormal">
    <div class="content-body">
      <el-form ref="form" :model="form" label-width="150px" label-position="right" :rules="formRules">
        <div class="form">
          <div class="tab" v-if="pageParam.total === 1">
            <div class="tab-title"><label>吊销信息</label></div>
          </div>
          <div class="form-body">
            <el-row v-if="pageParam.total === 1">
              <el-col :span="12">
                <el-form-item label="统一社会信用代码" class="bt0">
                  {{ revokeInfoList[0].uniscid }}
                </el-form-item>
              </el-col>

              <el-col :span="12">
                <el-form-item label="主体名称" class="redItem bt0">
                  {{ revokeInfoList[0].entname }}
                </el-form-item>
              </el-col>
            </el-row>

            <el-row v-if="pageParam.total === 1">
              <el-col :span="12">
                <el-form-item label="决定文书编号" class="bt0">
                  {{ revokeInfoList[0].writsno }}
                </el-form-item>
              </el-col>

              <el-col :span="12">
                <el-form-item label="处罚决定日期" class="redItem bt0">
                  {{ $utils.parseTime(revokeInfoList[0].revokedate, "{yyyy}年{mm}月{dd}日") }}
                </el-form-item>
              </el-col>
            </el-row>

            <el-row v-if="pageParam.total === 1">
              <el-form-item label="决定机关名称" class="bt0">
                {{ revokeInfoList[0].punishOrgCn }}
              </el-form-item>
            </el-row>

            <el-row v-if="pageParam.total === 1">
              <el-form-item label="行政处罚内容" class="bt0">
                {{ revokeInfoList[0].content }}
              </el-form-item>
            </el-row>
          </div>
        </div>

        <div class="form">
          <div class="tab">
            <div class="tab-title"><label>吊销勘误信息</label></div>
          </div>
          <div class="form-body">
            <el-row v-if="pageParam.total > 1">
              <el-form-item label="批量吊销勘误主体信息">
                <el-button size="medium" type="primary" @click="showEntList">批量吊销勘误主体名单<i class="el-icon el-icon-s-order" style="margin-left:5px" /></el-button>
                <el-button size="medium" type="primary" @click="exportEntListExcel">导出Excel<i class="el-icon" style="margin-left:5px" /></el-button>
              </el-form-item>
            </el-row>
            <el-row class="lh0">
              <el-form-item label="勘误信息项">
                <el-row :span="10" style="border-left:0">
                  <el-select v-model="modifyItem" @remove-tag="removeTagEvent" placeholder="请选择需要勘误的信息项" class="custom" :multiple="true" :disabled="curNodeID !== 'feedbackEnter' || onlyShow" style="width:100%">
                    <el-option
                      v-for="item in modifyItems"
                      :key="item.value"
                      :label="item.label"
                      :value="item.value"
                    />
                  </el-select>
                </el-row>
              </el-form-item>
            </el-row>

            <el-row v-if="modifyItem.includes('听证公告日期')" class="lh0">
              <el-form-item label="勘误后的听证公告日期">
                <el-date-picker
                  v-model="form.revokeHearDate"
                  type="date"
                  :disabled="curNodeID !== 'feedbackEnter' || onlyShow"
                  value-format="yyyy-MM-dd"
                  placeholder="选择日期">
                </el-date-picker>
              </el-form-item>
            </el-row>

            <el-row v-if="modifyItem.includes('吊销决定日期')" class="lh0">
              <el-form-item label="勘误后的吊销决定日期">
                <el-date-picker
                  v-model="form.revokeDecDate"
                  type="date"
                  :disabled="curNodeID !== 'feedbackEnter' || onlyShow"
                  value-format="yyyy-MM-dd"
                  placeholder="选择日期">
                </el-date-picker>
              </el-form-item>
            </el-row>

            <el-row class="lh0">
              <el-form-item v-if="curNodeID === 'feedbackEnter' && !onlyShow" label="请上传审批材料" class="upload bt0">
                <el-upload
                  :action="uploadPath"
                  :data="{bizseq:bizseq,attachtype: '1'}"
                  :on-remove="removeFile"
                  :on-success="uploadCallback"
                  :on-preview="previewFile"
                  :before-upload="beforeFileUpload"
                  :before-remove="beforeRemove"
                  accept=".doc,.docx,.xlsx,.xls,.pdf,.jpg,.zip,.rar,.7z"
                  multiple
                  :file-list="fileList"
                  style="max-width:800px;display: inline-block"
                  class="uploadFileList"
                >
                  <div style="display: inline-block;">
                    <el-button style="display: inline-block;margin-right:10px" size="small" type="primary">点击上传</el-button>
                    <div slot="tip" style="display: inline-block;" class="el-upload__tip">只能上传jpg/png/pdf/doc/docx/xls/xlsx/rar/zip/7z文件，且单个文件不能超过20M</div>
                  </div>
                </el-upload>
              </el-form-item>
              <el-form-item v-else label="材料列表" style="height: 100%;" class="bt0">
                <ul style="list-style:none;padding:0;margin:5px;">
                  <li v-for="item in fileList" :key="item.id" style="line-height: 30px">
                    <el-link style="font-size:16px" @click="handlePreview(item)">{{ item.name }}</el-link>
                  </li>
                </ul>
              </el-form-item>
            </el-row>
          </div>
        </div>

        <div class="form">
          <div class="tab">
            <div class="tab-title"><label>处理意见</label></div>
          </div>
          <div class="form-body history">
            <div v-if="historyLog.length == 0" class="none">暂无历史意见</div>
            <el-steps direction="vertical" class="correct">
              <el-step v-for="(each,index) in historyLog" :key="'historyLog'+index" :title="each.step + '人：' + each.handler + ' ' + each.step +'日期：' + each.handledate " :description=" each.opinioncontent " status="finish" />
            </el-steps>
          </div>
        </div>

        <div v-if="!onlyShow">
          <div v-if="curNodeID !== '' && curNodeID !== 'endFeedback'" class="form">
            <div class="tab">
              <div class="tab-title"><label>{{ opinionTypeName }}</label></div>
            </div>
            <div class="form-body">
              <el-row>
                <el-form-item v-if="curNodeID !== 'feedbackEnter'" label="是否通过" prop="nextNodeID">
                  <div style="display:inline-block;">
                    <el-radio-group v-model="form.nextNodeId">
                      <el-radio :label="nextNodeID">通过</el-radio>
                      <el-radio :label="'overFeedback'">不通过</el-radio>
                      <el-radio :label="returnNode">回退</el-radio>
                    </el-radio-group>
                  </div>
                </el-form-item>
              </el-row>

              <el-row>
                <el-form-item :label="opinionTypeName" prop="opinion">
                  <el-col :span="24">
                    <el-input v-model="form.opinion" type="textarea" placeholder="请输入意见" />
                  </el-col>
                  <el-col :span="12">
                    <label>常用语</label>
                    <el-select v-model="opinion" style="width:100%" placeholder="请选择" class="custom">
                      <el-option
                        v-for="item in opinionOptions"
                        :key="item.value"
                        :label="item.label"
                        :value="item.value"
                      />
                    </el-select>
                  </el-col>
                </el-form-item>
              </el-row>
              <el-row>
                <el-form-item v-if="curNodeID !== 'approvelist' && form.nextNodeId !== 'overFeedback' && form.nextNodeId !== 'feedbackEnter'" :label="nextOne" prop="reviewerId">
                  <el-col :span="12">
                    <el-select v-model="form.reviewerId" placeholder="请选择审核人" class="custom" style="width:100%">
                      <el-option
                        v-for="item in reviewer"
                        :key="'reviewer'+item.primaryKey"
                        :label="item.name"
                        :value="item.primaryKey"
                      />
                    </el-select>
                  </el-col>
                </el-form-item>
              </el-row>
            </div>
          </div>
        </div>
      </el-form>

      <div v-if="nodes.length > 0 && nodes[0].curruserid === user.primaryKey && (curNodeID !== 'endFeedback' || curNodeID !== 'overFeedback') && !onlyShow" class="submit-box">
        <el-button v-loading="submitLoading" type="primary" @click="submitForm">提交</el-button>
        <el-button v-if="curNodeID === 'feedbackEnter'" v-loading="submitLoading" type="primary" @click="endSubmit">结束流程
        </el-button>
        <el-button @click="$router.back()">返回</el-button>
      </div>
      <template v-if="onlyShow">
        <el-button @click="$router.back()">返回</el-button>
      </template>
    </div>
    <el-dialog
      title="批量吊销勘误主体名单"
      :visible.sync="showEnt"
      width="90%"
    >
      <el-table
        v-loading="loading"
        :data="revokeInfoList"
        tooltip-effect="dark"
        style="width: 100%; min-height: 380px"
        :fit="true"
        :header-cell-style="{background:'#8cc3fb',color:'#fff'}"
        :row-class-name="tableRowClassName"
      >
        <!-- <el-table-column v-if="revokeInfoList.length > 1" class="no" type="selection" min-width="20" align="center" /> -->
        <el-table-column prop="index" label="序号" min-width="50" align="center" />
        <el-table-column prop="uscc" label="统一社会信用代码/注册号" min-width="110" align="center" />
        <el-table-column prop="entname" :show-overflow-tooltip="true" label="主体名称" min-width="180" align="center" />
        <el-table-column prop="writsno" :show-overflow-tooltip="true" label="决定文书号" min-width="160" align="center" />
        <el-table-column prop="revokedateCN" :show-overflow-tooltip="true" label="处罚决定日期" min-width="100" align="center" />
        <el-table-column prop="punishOrgCn" :show-overflow-tooltip="true" label="决定机关名称" min-width="120" align="center" />
      </el-table>
      <div>
        <el-row class="bl0">
          <el-col :span="12">
            <el-pagination
              :current-page="pageParam.curPage"
              small
              layout="prev, pager, next"
              :total="pageParam.total"
              @size-change="pageSizeChange"
              @current-change="pageIndexChange"
            />
          </el-col>
          <!-- <el-col :span="12">
            <div class="dialog-box">
              <el-button type="primary" size="mini" @click="showEntList">确定</el-button>
            </div>
          </el-col> -->
        </el-row>
      </div>
    </el-dialog>
  </div>
</template>

<script>
import { removeAttachementById, listAttachmentByBizseq } from '@/api/attachment'
import { getCorrectionsDetail, nextRevokeCorrectionsProcess } from '@/api/revoke'
import { getUsersWithPermission } from '@/api/user'
import { validBeforeUpload } from '@/api/fileUpload'
import { taskOpinion } from '@/api/task'
import { isMenHu } from '@/utils/utils'

export default {
  data() {
    return {
      user: JSON.parse(sessionStorage.getItem('user')),
      onlyShow: false,
      busId: '',
      nextOne: '',
      opinionTypeName: '',
      bizseq: '',
      workflowId: '',
      tasklistid: '',
      revokeInfo: {},
      form: {
        entName: '',
        regNo: '',
        opinion: '',
        revokeHearDate: '',
        revokeDecDate: ''
      },
      formRules: {
        opinion: [
          { required: true, message: '请输入意见', trigger: ['blur', 'change'] }
        ],
        reviewerId: [
          { required: true, message: '请选择审核人' }
        ]
      },
      modifyItem: [],
      modifyItems: [{ value: '听证公告日期', label: '听证公告日期' }, { value: '吊销决定日期', label: '吊销决定日期' }],
      opinion: '',
      opinionOptions: [{
        value: 0,
        label: '拟同意,呈领导审核。'
      }],
      historyLog: [],
      uploadPath: `${process.env.VUE_APP_BASE_API}/attachment/uploadAdvance`,
      fileList: [],
      reviewer: [],
      nodes: [],
      curNodeID: '',
      nextNodeID: '',
      returnNode: '',
      submitLoading: false,
      revokeInfoList:[],
      showEnt: false,
      pageParam: {
        curPage: 1,
        total: 0,
        pageSize: 10
      },
      loading: false,
    }
  },
  watch: {
    // 意见渲染
    opinion() {
      let name = ''
      this.opinionOptions.forEach(each => {
        if (this.opinion === each.value) {
          name = each.label
        }
      })
      this.$set(this.form, 'opinion', name)
    }
  },
  mounted() {
    this.bizseq = this.$route.query.bizseq // 获取跳转携带的参数bizseq
    this.workflowId = this.$route.query.workflowId
    this.tasklistid = this.$route.query.tasklistid
    this.onlyShow = this.$route.query.onlyShow === 'true'
    // 加载常用语
    this.opinionOptions = this.$util.getCommonWordsWithModule(this.user.primaryKey, '批量吊销勘误')
    // 加载主体详情
    getCorrectionsDetail(this.bizseq,this.pageParam.curPage,this.pageParam.pageSize).then(res => {
      if (res.code === 0) {
        const detail = res.data.detail || {}
        this.form = {
          ...detail
        }
        this.revokeInfoList = []
        this.pageParam.total = res.data.totals
        let i = 1
        const pageStart =
          (this.pageParam.curPage - 1) * this.pageParam.pageSize
        res.data.revokeInfoList.forEach((each) => {
          each.index = pageStart + i++
          each.uscc = each.uniscid ? each.uniscid : each.regno
          each.revokedateCN = this.$utils.parseTime(each.revokedate, "{yyyy}年{mm}月{dd}日")
          this.revokeInfoList.push(each)
        })
        this.entType = detail.entType
        this.nodes = res.data.nodes || []
        this.renderNode()
        this.loadReviewer()
        this.nodes = res.data.nodes || []
        this.busId = detail.busId

        // 通过是否有值来判断用户是否勾选了修改项
        if (this.$util.isNotEmpty(this.form.revokeHearDate)) {
          this.modifyItem.push('听证公告日期')
        }
        if (this.$util.isNotEmpty(this.form.revokeDecDate)) {
          this.modifyItem.push('吊销决定日期')
        }
      }
    })

    // 加载处办记录
    taskOpinion(this.workflowId).then(res => {
      if (res.code === 0) {
        res.data.forEach(each => {
          switch (each.opiniontype) {
            case '0': each.step = '经办'
              break
            case '1': each.step = '审核'
              break
            case '2': each.step = '审批'
              break
          }
          this.historyLog.push(each)
        })
      } else {
        this.$message.error('加载处办记录失败')
      }
    })

    // 加载附件清单
    if (this.$util.isNotEmpty(this.bizseq)) {
      const list = []
      listAttachmentByBizseq(this.bizseq).then(data => {
        data.forEach(each => {
          if (each.attachtype !== '0') {
            each.id = each.attachmentid
            each.name = each.filename
            each.url = `${process.env.VUE_APP_DOWNLOAD_URL}/` + each.temppath
            list.push(each)
          }
        })
        this.fileList = list
      })
    }
  },
  methods: {
    // 主体名单导出Excel
    exportEntListExcel() {
      this.$confirm('是否确认导出', '提示').then(() => {
        const url = location.origin + process.env.VUE_APP_BASE_API + '/revokelist/exportEntList?bizseq=' + this.bizseq
        window.open(url)
      })
    },
    //主体名单分页
    loadList(){
      if (this.loading) return
      this.loading = true
      // 加载主体详情
      getCorrectionsDetail(this.bizseq,this.pageParam.curPage,this.pageParam.pageSize).then(res => {
        if (res.code === 0) {
          this.revokeInfoList = []
          this.pageParam.total = res.data.totals
          let i = 1
          const pageStart =
          (this.pageParam.curPage - 1) * this.pageParam.pageSize
          res.data.revokeInfoList.forEach((each) => {
            each.index = pageStart + i++
            each.uscc = each.uniscid ? each.uniscid : each.regno
            each.revokedateCN = this.$utils.parseTime(each.revokedate, "{yyyy}年{mm}月{dd}日")
            this.revokeInfoList.push(each)
          })
        }
      })
      this.loading = false
    },
    // 分页大小改变
    pageSizeChange(pageSize) {
      this.pageParam.pageSize = pageSize
      this.loadList()
    },
    // 当前分页改变
    pageIndexChange(curPage) {
      this.pageParam.curPage = curPage
      this.loadList()
    },
    tableRowClassName({ row, rowIndex }) {
      if (rowIndex % 2 === 1) {
        return 'warning-row'
      }
    },
    // 查看主体名单
    showEntList() {
      this.showEnt = !this.showEnt
    },
    // 勘误事项移出触发事件
    removeTagEvent(tag) {
      if (tag === '听证公告日期') {
        this.form.revokeHearDate = ''
      } else if (tag === '吊销决定日期') {
        this.form.revokeDecDate = ''
      }
    },
    // 点击文件列表中已上传文件进行下载
    handlePreview(file) {
      var a = document.createElement('a')
      var event = new MouseEvent('click')
      a.download = file.name
      a.href = file.url
      a.dispatchEvent(event)
    },
    // 上传文件之前校验大小
    beforeFileUpload(file) {
      var that = this
      return validBeforeUpload(file, that)
    },
    // 移除文件前
    beforeRemove(file, fileList) {
      if (file && file.status === 'success') {
        return this.$confirm(`确定移除 ${file.name} ？`)
      }
    },
    // 上传文件预览
    previewFile(file) {
      if (file.url != null) {
        window.open(file.url, '_blank')
      } else {
        window.open(`${process.env.VUE_APP_DOWNLOAD_URL}/` + file.response.data.temppath)
      }
    },
    endSubmit() {
      this.$confirm('是否结束流程？', '提示').then(() => {
        this.submitLoading = true
        this.form.bizseq = this.bizseq
        this.form.workflowId = this.workflowId
        this.form.tasklistid = this.tasklistid
        this.form.opiniontype = this.curNodeID === 'feedbackEnter' ? '0' : this.curNodeID === 'handleFeedback' ? '1' : '2'
        this.form.opinioncontent = this.form.opinion
        this.form.tasklistid = this.tasklistid
        this.form.nextUserIds = this.form.reviewerId
        for (const i in this.reviewer) {
          if (this.reviewer[i].primaryKey === this.form.reviewerId) {
            this.form.nextUserNames = this.reviewer[i].name
          }
        }
        this.form.nextUserNames = this.user.nickname
        this.form.nextUserIds = this.user.primaryKey
        this.form.nextNodeId = 'overKwFinish'
        this.form.curNodeId = this.curNodeID
        nextRevokeCorrectionsProcess(this.form).then(res => {
          this.submitLoading = false
          if (res.code === 0) {
            this.$message.success('提交成功')
            // this.$router.go(0)
            if (isMenHu()) {
              // 信创门户环境跳转回待办
              window.location.href = '/aiccs/#/todo/list'
            } else {
              this.$router.back()
            }
          }
        })
      }).catch(() => {
      })
    },
    // 发送提交
    submitForm() {
      if (this.submitLoading) return
      this.$refs.form.validate(valid => {
        if (!valid) return
        this.$confirm('是否确认提交？', '提示').then(() => {
          this.submitLoading = true
          this.form.bizseq = this.bizseq
          this.form.workflowId = this.workflowId
          this.form.tasklistid = this.tasklistid
          this.form.opiniontype = this.curNodeID === 'feedbackEnter' ? '0' : this.curNodeID === 'handleFeedback' ? '1' : '2'
          this.form.opinioncontent = this.form.opinion
          this.form.tasklistid = this.tasklistid
          this.form.nextUserIds = this.form.reviewerId
          for (const i in this.reviewer) {
            if (this.reviewer[i].primaryKey === this.form.reviewerId) {
              this.form.nextUserNames = this.reviewer[i].name
            }
          }
          // 办结使用当前用回信息作为下一节点信息
          if (this.curNodeID === 'approvelist' || this.form.nextNodeId === 'overFeedback' || this.form.nextNodeId === 'feedbackEnter') {
            this.form.nextUserNames = this.user.nickname
            this.form.nextUserIds = this.user.primaryKey
          }
          // this.form.nextNodeId = this.nextNodeID
          this.form.curNodeId = this.curNodeID
          if(this.form.revokeDecDate != null && this.form.revokeHearDate == null){
            this.form.revokeHearDate = ''
          }
           if(this.form.revokeDecDate == null && this.form.revokeHearDate != null){
            this.form.revokeDecDate = ''
          }
           console.log( this.form.revokeDecDate,this.form.revokeHearDate)
          nextRevokeCorrectionsProcess(this.form).then(res => {
            this.submitLoading = false
            if (res.code === 0) {
              this.$message.success('提交成功')
              // this.$router.go(0)
              if (isMenHu()) {
                // 信创门户环境跳转回待办
                window.location.href = '/aiccs/#/todo/list'
              } else {
                this.$router.back()
              }
            }
          })
        }).catch(() => {})
      })
    },
    uploadCallback(res, file) {
      if (res.code === 0) {
        file.id = res.data.attachmentid
        this.$message.success('上传成功')
      }
    },
    // 移除文件回调
    removeFile(file) {
      if (file && file.status === 'success') {
        removeAttachementById(file.id).then(res => {
          if (res.code === 0) {
            this.$message.success('删除成功')
          } else {
            this.$message.error(res.msg)
          }
        })
      }
    },
    // 加载审核人
    loadReviewer() {
      if (this.nodes.length === 0) return
      const node = this.nodes[0]
      let perm = ''
      switch (node.currentnode) {
        case 'feedbackEnter':perm = 'revokeHandleCase'; break
        case 'handleFeedback':perm = 'revokeApprovalCase'; break
      }
      getUsersWithPermission(perm, this.user.orgId).then(res => {
        if (res.code === 0) {
          this.reviewer = res.data
        }
      })
    },
    // 节点渲染
    renderNode() {
      if (this.nodes.length > 0) {
        this.curNodeID = this.nodes[0].currentnode
        switch (this.curNodeID) {
          case 'feedbackEnter' : this.nextNodeID = 'handleFeedback'; this.$set(this.form, 'nextNodeId', 'handleFeedback')
            this.opinionTypeName = '经办意见'
            this.nextOne = '审核人'
            break
          case 'handleFeedback' : this.nextNodeID = 'approvelist'; this.$set(this.form, 'nextNodeId', 'approvelist')
            this.opinionTypeName = '审核意见'
            this.nextOne = '审批人'
            this.returnNode = 'feedbackEnter'
            break
          case 'approvelist' : this.nextNodeID = 'endFeedback'; this.$set(this.form, 'nextNodeId', 'endFeedback')
            this.opinionTypeName = '审批意见'
            this.returnNode = 'handleFeedback'
            break
          default: this.nextNodeID = ''
        }
      }
    }
  }
}
</script>

<style lang="scss" scoped>
.el-row--flex{
  /deep/ .el-form-item__content{
    height: 100%;
  }
}
.main-content{
  font-size: $table-content-font-size;
  .back-btn{
    position:absolute;
    right:40pt;
  }
  .content-header,.content-body{
    background: white;
    padding:20PX 10PX;
    border:1PX solid #eee;
  }
  .content-header{
    height:60PX;
    .title{
      font-weight: 700;
      font-size: $font-size-sub-title;
    }
  }
  .content-body{
    padding:20pt;
      .tab{
        .tab-title{
          label{
            display:inline-block;
          }
        }
      }
    .form{
      margin-bottom: 20pt;
    }
  }
}
.el-row {
  border-left: 1px solid $color-border;
}
.bt0 {
  /deep/.el-form-item__label{
    border-top: 0!important;
  }
  /deep/.el-form-item__content{
    border-top: 0!important;
  }
}
</style>
<style lang="scss">
.main-content.abnormal{
  .el-select .el-input.is-disabled .el-input__inner{
    color: unset;
  }
  .el-form-item{
    margin-bottom:0;

    background: $color-form-label;
    .el-form-item__label{
      padding-left: 10px;
      font-size: $table-content-font-size;
      border-top: 1px solid $color-border;
    }
    .el-form-item__content{
      background: white;
      padding: 10px;
      font-size: $table-content-font-size;
      border-top: 1px solid $color-border;
      border-right: 1px solid $color-border;
      border-left: 1px solid $color-border;
    }
  }
  .el-form-item:last-child{
    border-bottom: 1px solid $color-border;
  }
  .form-body.history{
    padding:15px;
    border:1px solid $color-border;
  }
  .el-form-item.is-error .custom .el-input__inner{
    border-color:$color-border;
  }
  .el-table-column--selection .cell {
    padding-right: 0px;
  }
  .no {
    padding-left: 0px;
  }
  .el-table_9_column_61.is-left.is-leaf{
    .cell{
      padding-left: 0px;
      padding-right: 0px;
    }
  }
  .el-pagination{
    text-align: right;
  }
  .dialog-box{
    text-align: right;
  }
  .el-textarea.is-disabled .el-textarea__inner{
    color: #1c1e23;
  }
  .el-input__inner{
    margin-bottom: 5px;
  }
  .redItem .el-form-item__label{
    color: #bd2c00;
  }
  .uploadFileList{
    .el-upload-list__item{
      display: inline-block;
      width: auto;
    }
  }
  .correct{
    .el-step__description.is-finish {
      font-size: 16px;
    }
  }
  .fileRow{
    .el-row{
      display:flex
    }
  }
}
</style>
